let originalText = 'Fluchende Eltern oder gar Kinder, die am Morgen vergeblich auf den Schulbus warteten, waren in den Orten rund um die Außenstelle der Grundschule Neuhaus in Tripkau nicht zu sehen. Nur vereinzelt haben hier Schüler in den Klassen wegen des erneuten Warnstreiks der Busfahrer, zu dem die Vereinte Dienstleistungsgewerkschaft (Verdi) aufgerufen hatte, gefehlt, war aus dem Lehrerkollegium zu hören. Die Eltern hätten sich, wie bereits beim ersten Streik, in der Vorwoche gut untereinander organisiert.\n\n\
Ganz anders dagegen das Bild in den höheren Klassen, zumindest in der Theodor-Körner-Schule in Picher. „In der Grundschule und den fünften und sechsten Klassen haben kaum Schüler gefehlt. In den höheren, also ab der siebten, waren allerdings nur drei bis vier Schüler pro Klasse anwesend“, berichtet Schulleiter Michael Tiede auf Nachfrage. „Wir haben den Unterricht deshalb auch nach der vierten Stunde beendet. Das war vergangene Woche auch schon so“\n\n\
Dennoch habe die wiederholte Arbeitsniederlegung eine weitaus andere Dimension als die vorherige, ist von den Lehrern der Grundschule in Tripkau zu erfahren. „Das Problem ist das Abholen nach der Schule“ sind sie sich hinsichtlich des nun ganztägigen angesetzten Streiks sicher. So hätten viele Kinder Zettel von ihren Eltern mitbekommen, dass sie mit Bekannten oder Verwandten den Heimweg antreten konnten.\n\n\
Weiterlesen: Gewerkschaft legt Nahverkehr lahm\n\n\
Auch die sehr kurzfristige Ankündigung der Arbeitsniederlegung sehen die Lehrer kritisch und geben damit auch Rückmeldungen aus der Elternschaft wieder. Die Gewerkschaft dürfte sich mit diesem Verhalten also keine Freunde gemacht haben. „Ich kann nicht nachvollziehen, warum es diese superkurze Vorankündigung gab. Bei einer längeren Frist hätten sich die Leute darauf einstellen können“ meint Stefan Lösel, Geschäftsführer der Verkehrsgesellschaft Ludwigslust-Parchim (VLP) „Es gibt deshalb auch viel Unmut. Wir hatten mehrere hundert Anrufe von Leuten, die sauer waren. Der Tenor dabei ist, dass sie den Streik schon in Ordnung finden, aber die Ankündigungsfrist nicht“\n\n\
Die Kritik möchte die Gewerkschaft dagegen nicht auf sich sitzen lassen. „Wir wollten den Warnstreik eigentlich längerfristig ankündigen. Im Gegenzug wollten wir aber auch eine Absicherung von der Arbeitgeberseite, dass dann keine Streikbrecheraktivitäten geplant werden“ erklärt Christian Manke von der Verdi Landesbezirk Nord, Fachbereich Verkehr. Mit anderen Verbänden sei das möglich gewesen, mit dem Kommunalen Arbeitgeberverband Mecklenburg-Vorpommern, der die Tarifverhandlungen für die kommunalen Unternehmen führt, allerdings nicht.\n\n\
Das habe nicht nur die erste Warnstreikrunde gezeigt. „Auch diese Mal gab es einige Betriebe, die Streikbrecherprämien ausgelobt oder Rentner angesprochen haben, ob sie Dienste für hohe Sonderzahlungen übernehmen“ so Christian Manke, der den Nutzern des Öffentlichen Personennahverkehrs rät, sich täglich ab 18 Uhr zu informieren, ob die Busse am nächsten Tag fahren. „Bis zu dieser Uhrzeit versuchen wir die Streiks anzukündigen“\n\n\
Kommenden Dienstag findet die dritte Verhandlungsrunde über den Tarif im öffentlichen Omnibusverkehr in Mecklenburg-Vorpommern statt. Die Gewerkschaft fordert dabei weiterhin eine Erhöhung der Löhne und Gehälter um 2,06 Euro pro Stunde ab dem 1. Januar 2020 sowie zusätzlich einen Angleichungsbetrag von 100 Euro. „Die Forderungen sind ambitioniert, aber sie sind auch deshalb so gefasst, um eine Angleichung an das Vergleichsgebiet Schleswig-Holstein zu schaffen“ meint Hans-Martin Becken, Vorsitzender des VLP-Betriebsrats.\n\n\
Die Gründe für die Streiks hätten sich nach der letzten Verhandlung nicht geändert. Das Angebot der Arbeitgeber, insgesamt rund sechs Prozent mehr Geld in den kommenden drei Jahren, wurde als „substanziell nicht ausreichend“ abgelehnt. „Geld für neue Technik ist merkwürdigerweise immer da. Jetzt muss aber auch mal in Menschen investiert werden“ sagt Hans-Martin Becken. „Wir wissen, dass wir andere mit unseren Aktionen treffen, aber welche anderen Möglichkeiten hat man, um seine Forderungen durchzusetzen?“\n\n\
Die Streikenden kritisieren möchte Stefan Löses nicht, die Forderungen der Gewerkschaft hält er aber offenbar für übertreiben. „Die Verdi fordert im Schnitt 51 Prozent mehr Stundenlohn. „Das überfordert den Landkreis“ so der VLP-Geschäftsführer. Die Folge wäre wohl, dass dann Leistungen, sprich die Anzahl an Fahrten, die zuletzt ausgebaut wurden, gestrichen würden. „Ich hoffe deshalb, dass es am Dienstag einen Abschluss gibt, mit dem die Angestellten zufrieden sind und der Landkreis nicht überfordert wird“'

let inputCrypted1 = 'cedehnulF rEnlet erdo gra ,Kidern die am oMregn erighlcvbe afu end Sscbuuhl ,anttwree aernw ni dne tOenr drun um die Aletneesßul red uurcGsdhlen uNasheu ni Tuarkpi thinc uz e.snhe ruN zreltveien eabhn hire cShrüle ni edn salnseK gween dse uneenetr Wnastsrekir edr ,rauBrhsfe uz edm ide tirVeene fgwskitetestgunshscDailerne Ve(r)di enufrafegu ht,ate ,eegthlf wra sua mde leeuierrLgmlohk uz erhö.n eDi ltrEen etnäth csih, iew rseiteb iebm sernet ertSki in red ecVohrwo tgu enndrneitaeur itis.aegronr\n\n\
nzaG snread ggaeden sad lBid in edn heeönrh ,lnKsaes iuesdztnm in der rTohe-he-dKcrnlöuoreS in .ihePcr „In edr hurlduencsG udn ned nfenftü und hneetscs elaKnss eanhb amku Slrecüh .htefgel nI end ,hhenreö aols ba rde ibse,ent wrnea lnlearsgid nru reid sbi ivre ülreShc rpo sasKel en“n,sdawe hrtetbeic uleechiStrl ehcilaM Tidee auf hcag.fareN Wri„ beahn edn ehriUttncr shblaed huac hanc der rvnteei dSenut et.eednb aDs war gegeevrnan Wceho achu sochn s.“o\n\n\
Dncnohe heab edi rdeliothwee lnndgigitreeeuerAbs inee istuawe eernad ininosmDe asl ied erihovgr,e tsi nov nde ereLrnh dre uneGlsudrhc ni uTpaikr zu nra.heerf sa„D Plberom its dsa noAbelh chna rde ,ul“heSc dsin sie hisc hcntihiichls des unn ggnatzinegä tsgenteenza Sistker isrc.he oS nhttäe leive nKride ettZle von nihre erlEtn nmtbimoeke,m assd sie tim antekneBn odre etwnrndaVe ned wHeigme ttaennre kn.teonn\n\n\
rWtelneeesi: eGtfhkecwasr getl vkehreNrah hlma\n\n\
uhcA dei serh sirktugreizf günduginnAk der elenigAenesudrirgtb nhese edi erLreh rhsticik udn bnege dtima ucah müuknedengclR uas rde trchtfnsEale wrieed. iDe kGawethcsefr üfetrd schi mti semdie ntreaeVlh asol neike duenFer tehcmga n.hbae Ih„c nkan hctni hihnzlo,lenaecv ramwu se sedei peurzeuskr duVrnüagkgoinn agb. eiB ieenr änenglre tisFr htnetä isch eid eutLe rafuda enislnleet nnnke,ö“ mtein fneatS eöLsl, efhGschfrestürä edr gsahelrfkecsretelsVh -drluwgsmtcusahiiPL V(LP.) Es„ tbgi baelhds hcau vlie U.tumn iWr ettahn reremhe hrudent enrfuA nvo une,teL eid earsu eanr.w Der neTor dibae t,is asds sei den Srteik nocsh in dOnnrug dnief,n eabr eid iiugtAdksnünsgnrf c.nh“it\n\n\
eDi iKtkri ötcmeh die feGewraktsch ggeeadn hnitc uaf ihsc ienstz enslsa. r„iW oewllnt den tkeWrnisra htcgnieile eglgiritfärsn akn.üenigdn mI gngGzuee wtllone irw erab ahcu ieen ebnsAruicgh ovn edr brebegettseiAi,re ssad dnna neike ebeatitviirrtSrekäcnkhet ntalegp ed“,nrew krlteär isriatChn akeMn von der Vdeir deeLabirsznk roN,d ibeehrhcacF ehe.rVrk tiM aeerdnn nrbVdeäne ise asd mhclöig egnsew,e tmi med Kmnemnaluo eaevrdrbenrtbieAgb -nprnlromVg,ecrbemkeouM edr ide heainandrefnruTlgv frü die nammenkulo netreUnmhne htü,fr daillsgren cthni.\n\n\
Dsa heba incth nur eid tsere eWaedntkrusnrri igt.zeeg c„uAh diesse laM gab es nieeig br,Beeiet ide ecrthrSmeekrbieäpnri esatgoblu rode entnRre nscengaopher banh,e bo ies inesDte für hheo gruelnnhoeSzdna renb“ünemhe, so iinCahtrs ,knaeM erd nde nuzreNt eds etcfhlnÖfnie venrnesksPheorneahr tär, isch icghätl ab 18 Urh zu ,irfinneoerm ob ied suBes ma enntächs agT rfh.nae s„Bi zu rsdiee zhrteUi rhnuecsve rwi die sSkeirt üz.nennga“uikd\n\n\
mKednnmeo gtenDias fnetdi eid irtdte dnualeenhsdrrVgun rbüe end fairT im feeöihnclnft hevnsueOrbrkim in lbpgmonMrroemuck-erneV tttas. eiD ksfwhecGrtea oredtfr dieba trneihiwe eine röunEghh der henLö dnu etäehGlr mu ,026 oruE pro nuteSd ba med .1 anuarJ 2200 eosiw sctzlhizuä inene gecrsnghgntaibuleA von 010 .oEur i„De reFdgeuronn sdni oeb,itmriiatn abre eis insd cahu bdslaeh so stfseg,a um ieen hlncuinggAe na dsa rscilVeigtbheeeg ei-eswlciHnhgotlSs zu hc“f,sfane entim MtnsraHi-an keen,Bc terVesdnrzoi sed BsrPetrieV.aL-stb\n\n\
eDi drnüeG ürf ied ktiSres tenäth sich nhca dre tltezen nlhVgnarued incth edteägr.n saD btgAeon red ,ritbebeArge itsamgnse durn essch tnzeoPr hmer dleG in dne dkmnenome ider aJhern, euwrd sal balistzse„nul ihcnt eeuhadcnirs“ algebe.hnt Gld„e üfr eune hTinkec tsi eemkswreeüiriwdgr merim d.a tztJe ussm rbae ucah aml ni ecnnseMh nivsiterte ewn“e,dr tasg rntas-iaMHn Be.cenk iWr„ ,sinswe asds wir aneerd tim rneesnu kinAoten ftnere,f raeb elewch erneand gntkiöMehlcei tha na,m mu eisen rneeuFongrd urdse?ntuzeh“zc\n\n\
ieD ntrknediSee rkiesnireit öehtmc Sentaf Lselö ,nchit dei dgeuneFronr rde tfercewskaGh ählt re raeb arfoebnf üfr übetenbreri. e„iD edvir edtrofr im chiSttn 51 zontrPe merh huntdoSle.nn sDa botdüfreerr ned na,r“siekLd os erd sshe-äcG.ürVtrefhLfP iDe eoglF werä lhow, sdas andn enn,guitsLe srhpic ide Alznah na nr,hFate edi ltuzzet setgaaubu drneu,w geetnshicr ewnrd.ü hI„c hfefo dlbehas, asds se ma gstainDe neeni sAslcbhus bgti, mit mde eid tneglensleAt nreeifudz snid udn rde Leskirnda ntcih errütdfrobe r“iw.d'

let inputCrypted2 = 'Fnhdculee nlEtre erod agr ,niKrde die am orMnge vrcglihebe afu dne hSsbcluu awn,rette wrnae ni nde Onetr udrn mu die eteeAunlßsl red Gnruhcldeus uhesNau ni aruikpT ncthi uz h.nsee rNu erentlevzi haenb ehri lerühcS ni end lasesKn enwge sed reetnnue isWtrnsaekr red r,rBehsfau uz edm edi neVriete esrngutntgskieceaslisfhewDt diV)re( nfgfueraeu htte,a elhg,eft raw aus dem heelrokirLuelgm zu .hrneö iDe enElrt hetntä sc,ih wei teirseb ebmi ntseer ekSirt ni dre cwrehVoo ugt itueaernenndr enisit.garor\n\n\
Gzan asnrde gedenag ads ilBd ni ned nhröehe ,nlsasKe muiztdsen ni edr nSörcr--eruhTodKeohel in r.hicPe I„n der Gcurenhulsd udn den nfftenü nud hensscte lsanKse heban umak hecrlüS htlf.gee In dne erö,hnhe soal ab der tbsi,ene eawrn insraeldlg nru erid isb vrei ülcerhS por lsKsea s“d,newaen hittecbre tSuhlclreie ehiaclM deTei afu .fNaaecgrh ri„W hneab nde rnrhcUteit lbaesdh acuh hcna red ernivet nteudS dnb.teee aDs wra ggennevare eochW ahcu cshno “o.s\n\n\
oDnchen eabh dei tleeheowdri idseeAbureigntgenlr eein iweatsu enaedr nesDionmi lsa ied ,eoirrgehv tis von nde Lrenreh dre ndclhusreuG ni kaTrupi uz fnr.reaeh sD„a Pbmrleo its sad bAnheol hcna dre hu,S“cel sind ise hisc hinisihlthcc sed unn iägeagnnzgt atezensgnet Sserkti c.ishre So eähtnt elvei ienrKd etlZte vno iehrn Ertlne ,mmotmekenib dssa eis tmi aneentBkn erdo ndnwtaeVre edn wHgeime enratten o.ennknt\n\n\
Weie:enestrl ahGceetfksrw lteg reNhhvkrae mlah\n\n\
cuhA edi sher zrurkgtiifes ngAngnikudü dre ienAuegsretbdgilnre neshe ide erehrL hicskrti dnu begne datmi uahc egdmnnckluRüe asu der canrhfleEstt ri.ewed ieD asrkchwtGefe üdtfre icsh itm isemed lretnhVea olsa eneki Fudeern thacgem .hnaeb Ic„h nnak tchin loezvi,hneclhan umraw se eside ersepruzku ndrnüagungViko b.ga eiB erein äeregnln rFist tetänh cihs dei ueLet uaafdr lnineslete ,önnenk“ inetm fatnSe söLel, chetGrsrffeühäs erd eersahglkVlrcsetfseh scLi-Phgmsadrtuwuil VLP(). E„s btig ldbshae huca ivel mu.tnU rWi ttaehn rreheme edthnur nfeuAr nov uetne,L dei usrae wea.rn erD nreoT abdie ts,i dssa ise end tekrSi scnho ni gurnOdn inef,nd rabe ide nsfrgniügtdukAnis c“hn.ti\n\n\
iDe rKikti cmtehö die akefrGehtscw daneegg hctni afu shic etzsni aens.ls „irW llnowte nde tisraWnrek eiithcgenl grtislgfrenäi nianüne.dgk Im uegzngeG tewlnol wri reba cauh eein srAuginechb nvo der e,rbebeiAitegstre sasd adnn kenie vSitathriieerkcereänttbk tnleapg edne,w“r ätrelkr asrtihiCn enkaM vno der rVied Lsernekidzba ,oNrd eerhaihccbF Vhkr.ere itM dnneaer ädeVbrnne sie sda öglmich e,sneweg mti med enumoKlnma bbrbervengaetirAde bpenk,rgroueMnVm-orlecm erd dei nugrirnanaleTdfhev ürf die aunomeknml nterehnUmne f,hütr isrlngaedl hc.tin\n\n\
Das haeb tnchi rnu die ester nrWtdrneirksuae gietzeg. „hcAu ssdiee Mla gab es ingeie teb,Breie ide kährerpeetnirbSemicr galsotube rdeo nnRrete rponaeecnshg hb,ena bo ise niteDes üfr ehho ragSeonednnzluh e,en“mhbeürn os sathrinCi kne,Ma red edn Nrtuezn esd flenhfcnÖeti kesranPrhrsnonhveee tr,ä shic läthcig ba 18 hUr zu nofni,reirme ob edi useBs ma tcänehns gTa nf.erha „isB uz rdeesi htriUez uehcnvrse iwr ied istSkre uniake.g“dznnü\n\n\
omnmdKnee egstaDni findet ide drtiet elrdnshuunVrndeag rebü nde Tirfa im efenhncöltfi riebnuOermhsvk ni rpeornkmeolMugbr-mVecn atst.t Die tesrGeckfhwa trerdof aibde whneirtei neei röghEhun rde neöhL dun hGetärle um 06,2 oEru pro tdSeun ba med .1 nauarJ 0220 wsoei iucshztlzä ennie nAubntaiegchgsgler vno 001 .oEru „Dei redgronnFue isdn tmeb,iitonair brea eis sdin huac dabehls os gfasset, mu eien eiuclgAgnnh na dsa lrgitVbhcgeseiee cgtwso-nHSshlleiie uz hf“ns,fcea tneim s-riHantMna knBece, zeotsnrdrieV esd V.-bteLrseBistaPr\n\n\
eiD Gnedür frü dei sSrteik tnhetä chis ahcn red tneeltz lnVngehradu ichtn .neterdgä aDs bgetAon erd Aegr,bbereit nisgeasmt ndur shsec tePznro mehr elGd ni ned noedemnmk erdi Jner,ha uewrd sla zsie„bltlsnua htcin ecih“darseun tnelba.ehg eGld„ üfr eenu ihnTkec tsi igkewrereirdüsewm irmem ad. tzJte sums bear chau lma ni nMheencs vtiteesirn er,n“dwe tasg Mrta-sniHna kcenBe. W„ir ,wsnesi sads rwi eernda tmi nsurene nAoiknet ffnert,e aerb ehwecl nardnee cnketgöhMelii hat am,n mu neeis energurdonF e“crtzszu?uenhd\n\n\
Die eendkinreSt srknieterii cthmeö ntSfae sölLe tnci,h eid negroerFdnu rde rGfahktsewec hätl re erab nareboff für ei.breürtebn „iDe edriv rotrfde mi ihttcnS 15 nPreozt mhre h.tSednnuoln Dsa eürforrebdt ned a“Ldenrsk,i os edr fGätLrPhs.üeeh-fsrcV Die gFeol werä ,hwlo adss nadn tsne,Lnuegi ihsrpc die zAnalh na hFea,nrt edi ettulzz utaagbuse uednw,r tsehingecr wn.redü „hIc ehoff h,elabds dsas es ma aenDtisg ninee cbssAsulh gtb,i itm emd die ltnAegenltes uzdienfer insd udn edr Lsenriakd ctnhi ferbdüoterr r“wdi.'

let inputCrypted3 = 'hdnlcFeue neEltr edro agr rndeKi, dei ma roMgen eievrhlbgc fua nde husublSc wettnaer, anwer ni den trOne udnr mu ide tueeAsnlelß dre uuercdlshnG hausueN ni upakiTr incth zu n.ehse Nru zerevilten nabeh heri hcüreSl ni nde eaKnssl egnew esd enrtneue ksrenWsatri rde Bu,rsarfhe zu mde ied eeeirVtn gtsrtthelsDcinwsuifeegasnek i)erdV( gfruefuean ehtt,a thgel,fe rwa uas mde erughkiereLlmlo zu hen.rö eiD nrElte eäntth csi,h iwe eerbtsi emib nertes kStire ni red hVrcoweo utg rtninnadeueer ag.strorinei\n\n\
aGnz dresna aenggde asd Bild in end henrheö nsesl,aK mzudinste ni rde KrredohlröuecheSTon-- ni rceiP.h „In rde eGruudnlchs dun end efntünf und thssenec aKelsns eabhn mkua reShlcü eeghtl.f nI ned hhre,enö lsao ab dre eit,nebs wrean asgrdlnlei nru ider sbi eivr lrühcSe por sleasK “n,wasdene chttbiree hlSetclreui cleiahM Teedi afu h.agafNecr i„rW abehn dne hUirettcrn dhlaesb ucha cnah der ienvetr Stdeun etedben. asD arw eevnnggare hWcoe ucha hocsn o.s“\n\n\
Dnoechn aebh eid eehwrditloe bAeeeuigiserldgrtnn eien uatwsie nerdea Diimeonns als ied v,geiroehr tis onv nde nrLeerh der unshruelGdc ni kpaTiur zu aenerfhr. a„Ds rPemlob its dsa hblAoen chan red hle,S“uc idsn ise cish ictcihislhnh eds unn ageggtniänz gstzeeteann tsSrkei ecs.ihr oS htneät ivele reKndi Ztelet von heinr eEltnr nmekmbitoem, sads ies tim nennakeBt oder Vraeenndwt dne Hmwgeie naettenr notenkn.\n\n\
ee:sWrelneit kceGharsftew legt erearhhNvk lahm\n\n\
ucAh ide eshr rkrisfegiuzt üingugkndAn der nenbelidegegrrsiAtu esneh ide Lrehre htsirikc dnu beeng tdima chua üuRenklgmndce uas erd recElthnftsa e.dwire ieD trfcehGswkae füertd hsci imt meieds anlteeVhr alos kieen enrFeud ghceamt bna.he cI„h nkan hctni eha,lzincehnvlo ruawm se deeis uszprkeeur gknrduonüVaing bga. eiB erien ärelnnge sitrF näthte hisc dei teuLe fudara lstninleee “ne,knnö ietnm eftaSn l,öesL rrhäefefthcüGss dre Vskfgeersslteelchrha dsLwl-sughiaPturcmi .VL)(P s„E bgit hdables uhac vlie m.nUtu Wri nehtat eemrhre edtrhnu Aunerf nvo teLenu, ied rusae wenar. Der noTre debia i,ts assd ise edn rSetik nscho in dngOurn nin,def bear ied fsükrngtigAdunsni i“tnhc.\n\n\
Dei iikrKt mechtö edi echwkGtrfsea edeggna nhcit fau ihcs enzsti al.snes riW„ oenlltw ned krnWrtsaie eeihilgtnc iltifenärrsgg i.ennngdküa mI ngGueezg woltenl wir eabr acuh eien ghusbAirecn onv erd ,bgeertseiiAtbeer asds dnna eekin tSnikevacietiehttbkrrreä tngeapl nrdew,“e ätelkrr rihaniCst nkeaM von erd rideV aenidrzbsekL d,roN hhbriccaFee ee.rhkVr itM reneadn nVbräedne ies dsa iglchmö s,wgeeen mti edm laneounmKm riednbvberaebArget V,egkprm-ecloMnbnmroeru edr eid ernifnedTanvulhrag rüf ide lnemomknua eeehrnUmtnn hf,ütr ergdalslin ihntc.\n\n\
asD hbae ihcnt rnu ide teser enitWrnersurkda g.ietgez cuhA„ eisesd alM gab es eiigne Beeibt,re die pätrrebeimSrenrhkcie obluesgta reod eretRnn neogerancshp ,ehbna ob ise eiseDtn rüf hhoe nznelngSedrouah “erebnmüne,h so tChsaiinr kMne,a dre edn trnzueN dse eihtfÖclnnfe eensnrhePesronharvk t,rä sich ichgält ba 18 hUr zu imfr,oernien bo edi sBuse am nescnhät gTa ha.renf iB„s uz irdese hrteUzi cnuveehsr wri eid eiktSrs inauzn“.dngüke\n\n\
eodmnmKen aengsiDt enfdti ide retdti heeunudlsdVrnnagr breü ned irTfa im hnceeftöifnl ekmeuriOsrnhvb ni bemgMlnkVeorcrnrueo-pm ta.stt eDi artGshfekcwe rfredto aiebd ihteniwer eien ghurhEön erd heLön nud rGeäelht um 26,0 uEro rop Senudt ba mde 1. naaurJ 0022 oeiws hzutäzscil ineen eltabgnrhisAucgnge vno 001 Euor. e„iD rrneundegoF sdni rinb,ttmoieia ebra esi isdn cahu sbaeldh so seftsga, um inee lngcgAineuh an ads eritleVgcigheseb HntslwSiheecolgi-s zu h,fs“ceanf imten natrinMsH-a ekec,nB rsoezirteVnd des teBeLirVrss.taPb-\n\n\
eiD üendrG frü ied teSrisk täthen hics chan edr ettnelz nnlVruaegdh chnti g.eträdne saD eobgntA red ibrgArteee,b tesamsign rdun schse Pzertno mhre dGle in den nmekmendo iedr Jehnar, druew sal azsltbei„snul tchin eshnidecrua“ .tgbaelenh „edGl frü euen iTenckh tsi dwieiserreügerkwm imerm da. eJttz umss rbae uahc mal ni snnhMcee rvnetiiest edew,r“n tasg ni-ratnHMas B.nkcee r„Wi sw,nsie sads wir eeandr mti suenner enknoitA rnfftee, earb lwcehe nraened neMctikehögli tah n,am mu enesi orrgnFdueen cuhzd“e?rsenuzt\n\n\
ieD irtdnnSeeek riisiknrete heömtc ntfaeS elsöL ic,thn die Fdurenregno rde cGsrafhkteew älth re ebar bfonfear für ietbü.rebner „eiD rvide trorfde im nSithct 51 nzPoter emhr nned.toluShn saD eüdfetrrrob end “k,Lenasidr so dre L-.esrffchütPGehärsV Die logFe äwer lwho, asds ndna iLetnunges, prcsih dei hAzlan na aehFrn,t dei etzzlut subauagte uderwn, etgsncrieh wd.nrüe cI„h fefoh b,halsde asds es am nesagtiD eenin lbucAhsss i,bgt tmi emd edi lnetltnAeges niuzerfde nids ndu dre neskaidrL thcin retfrdbreüo rwi.d“'

let inputCrypted4 = 'cdneFulhe elEtnr reod agr ,Keidnr ied ma ornegM ieehgrlcbv fau dne Slsbcuhu tnewre,ta newar ni edn rtOen nrud mu ide ßleAleetuns rde ndcruuGhsle uuseNah ni Tuiakpr cnith zu eseh.n Nru envltezire eahbn erih rSehlüc in end nKealss gwene esd etuenenr resnairWkts der sru,rehafB uz med edi Vrnteiee tufngslgetwsnsDiaeeiectsrhk re)idV( efueurfagn a,tthe ftle,heg awr aus dme omirlhLegluerke zu n.höre Dei eltEnr ehtänt cs,hi iwe eibtres ebim teerns rkSeit in dre hVcorowe gut reneinrdtaune irai.tngrsoe\n\n\
znaG rdaesn agdnege das dBli in dne höehren ,lasneKs ztumnised ni edr lcho-h-reöSruoeTrKned ni Prechi. In„ red rcuneGsdhlu nud dne tffennü udn sceensth esaslnK ebhan mkua lüeShcr hleegf.t In edn hee,rnhö osla ab red es,ibnet ewnar gelsladnir run ried bsi ivre rcelSüh orp aslseK edsnna,“ew ittrcebeh utchrleileS Malecih eediT ufa egrNca.fah Wi„r naebh end Uerrichtnt bsladeh auch hanc red eetvnri dueStn edtneeb. saD arw egnnvrgeae hcoeW ahuc hcosn .so“\n\n\
cnhenDo aehb edi rlidewehote Adsirltugnbeeergnie eine taeiswu denare moiinensD sla die rhe,rogvei tsi von den Lrnehre edr lschudnrGue in rukTpia zu fhrreena. sDa„ oePmbrl sit dsa ohleAnb nahc dre ,lecuSh“ sidn esi isch chilhishticn sde nun gniaenggztä sgetetnaezn tkSiers rsh.eci oS thenät vleei Knierd tetZle onv irehn tnElre nt,iemekmobm sdas ies mti nneBentka ored enwatVdrne den iewemgH earettnn ket.nnno\n\n\
:eerstnieleW Ghceewkfasrt lget Nhrvahreek hmla\n\n\
hcAu die rshe gzsrkurfeiit nngikunüAgd red reeigrgsueAltinbned esenh die Lreehr sirtkcih und gnbee miadt cuha eegmnclRünkud sua dre lnfsehtratEc idwre.e eiD cwerkhtefasG efrtüd hsci itm imesde ehrntaeVl osla keeni udFeenr mgetahc nae.hb hI„c nank htinc l,invaehzolnche arwum es eeisd ukersuzrep güguoiaknrdVnn b.ga Bei ieenr ngäeenrl Ftrsi tätehn ishc dei tLuee aadurf eneetsnlli nnöen,k“ tienm nteSaf eöls,L sfhrärfcütGhsee der ereshsecksagelrVltfh u-shcautsdPigmrliwL (.PV)L sE„ gibt aehdsbl hcau ivel .tnUmu rWi enttha mrreehe nedrhtu fnrAeu von e,tnLue eid sruea ewr.an eDr oTnre daebi tsi, sasd ise nde rkSeti sohnc ni Ondrngu i,efndn ebra edi nsiiAkürdftgunsng “h.cnit\n\n\
Die Kriitk ctemöh die Gkfceswhtera neeadgg hictn fua isch tezins .snlsea W„ir lwtolne edn siknrWeart glheeciint rgtisriänegfl küann.egdin mI eGugngze neolltw iwr rbea achu neie Ascirguhben vno dre s,eibebtreeetiArg dass dnna eekni rincSetkiaebvteietkätrhr npgtlae nedwre“, älretkr rihnCasit Maken vno edr deriV zriLaebenkds o,Ndr rhccbFeaieh Veek.rhr Mti rndaene dnäbreneV sie das öchgmli e,wengse itm med oemnanuKlm ergtvbbianeeberrdA mgnV,broeloermpckuenM-r dre eid nnuagladfrheeriTnv üfr ide naelnkmmuo nrmUeentehn ,htüfr lerlsngdai ih.ctn\n\n\
Das habe nchit unr dei etrse riknurrseatnedW ziee.tgg huA„c desies Mal gab se ieineg eiBtre,be edi käebhprrreermnicStie utosbleag odre tenrRne spnhnaeoecrg eah,bn ob sei eenistD rüf oehh enhoeadglrzSunn eh“nürme,nbe so rChiastni ekMan, red dne tNzerun des litnnffhÖeec snarnrrnPvoehekehes rt,ä ichs lhgtäic ba 81 rUh uz irnfon,irmee bo die sseBu ma shtcenän agT nfreh.a „iBs uz eesidr etrUhiz nerceuvhs irw eid Ssetirk g.dnüiknzua“ne\n\n\
eKmnonedm gDsietan itdenf ied ttrdie dnnnreeuurgahVlds büer nde fTria mi ltcehffennöi Orrenuhsvbiemk in -enpmelrerVugMbkormonc tatt.s Dei sewahekcfrtG erofrdt ibdae etnriheiw eeni hgnuEhör der nöhLe dnu äreetGlh mu ,602 uroE pro dnuetS ba med .1 uaranJ 2002 ewiso äscltuizhz ineen cagenluniAgrbegsth nov 010 Euor. eDi„ nureFdgeron sdni tmb,itnaoriie aebr eis dnis hcua dhelasb so tegfssa, um enie geuiglnnAhc na dsa Velcheeeisbgtigr osgilcshnteSw-Heli uz ef,cs“nahf itnem nMsaH-rtani ke,Bnce dirensroezVt esd artt-bsiVPrLee.sB\n\n\
ieD üednGr frü eid Srkitse nttheä sich canh der ttenzel ledangunVhr incht nderet.gä aDs teoAnbg der rtee,eibArgb sgsmentia urnd hsecs eProztn mrhe deGl in edn dkonmmene reid Jhn,ear uwder asl „bsnluazilste htnci dheuinresca“ an.gltebhe Gled„ rüf ueen iehkTcn tis ikdwersmreiewüegr rmmie .da zetJt sums brae auhc aml in nhscneMe vteirsinet r“needw, satg tninsa-HarM B.ecnek iWr„ se,nswi ssad riw eneard tim esnurne innkoAet rftef,ne brea eclwhe eadnern nlMteikhöegic tha m,na um senei enFrgdnerou hzrne?td“eucsuz\n\n\
Dei rndSketeeni kneitrseiri ehtmcö tfSaen Lelös hctni, die eeugondrFrn der ahekcsfteGrw älht re earb farefbno für eürn.tbeebri „eiD rvedi tfordre im Sthntic 51 Portnze ermh tn.nlSheodun Das eetrüfrbord edn ,“Lsdikenar os red f-sPfhtsüVLr.rähecGe iDe eolgF äewr w,loh adss ndna Lutnien,egs ihrpsc die zAlnah an anrht,eF ide tteuzzl uugsabate urw,ned irthscgene rüdwen. Ich„ effoh halbesd, ssad se ma aDseingt ninee sssAhlubc bg,it tmi dem eid etneglstAnel erufeiznd sind dun erd dLeanriks htcni eorüfdrrteb i.w“dr'

let inputCrypted5 = 'dhFneclue tEnelr dreo gra ,neKdir ide ma genorM hlriebgvec afu end cSluhsub ntwtaere, wnrae ni dne rtneO dunr um ied eeAeußnsltl red chuedGnrlus Neusuha ni akrpuiT ithnc uz she.en Nur eeevzinrlt hbena heir Sührlce ni nde alesKns egenw eds erenuent itakenssWrr edr efrrahuB,s zu mde ide eterienV usnktntaeiwDeiehtclggfsessr V)ir(de gfefeaunru h,ttae heel,gtf awr usa dem emlrLreuilhogke uz r.nöeh Die rEtnel etthän c,shi wei erteisb embi ertnse itekSr in red rocewhoV gtu ieantennrduer rsegoirti.na\n\n\
anzG srdnae egnadge sad liBd in den öhreenh s,Knaels zditmusne in edr rrhdKSöereoucTl-neh-o in hreP.ci n„I erd luersndGcuh udn end üfetnfn dun tehsnces slaensK benah mkua clüeShr .ftelhge nI edn eöre,hhn olas ba dre ebn,teis awern graldleisn unr rdie bsi ievr lücrShe por eKalss ,esnenw“da tirecetbh tcerhSillue Mclihae deeTi auf eNr.haacgf iW„r nbhea ned tehrtnrUic bedshal ucha ncha der eirvten dnSteu eb.dntee asD wra aenvnggree Wceho uhac hncso .“so\n\n\
Deonchn abhe ied ewrltieheod rentersuAggenbeliid eien uiseawt nderae niminesoD sla eid egeo,hrrvi tsi nvo ned rrnheeL der huGsuecrndl ni krTpuai zu aer.rhnef D„as omPerlb sit das eAnholb hacn edr ucS,l“he disn sei shci licnshihctih sde nun niäzgggaetn eestztgaenn streiSk esrhci. So ätehtn ileve nrdeKi Zetelt von irneh etErln t,kmonimbeme adss sei mit nBenketan redo Vdnwtenrae dne iwHegem atenertn n.konent\n\n\
esilWeetnr:e artGkefhcwes gtel ehervhrkNa halm\n\n\
Ahuc ied rhes ruzrfeigsikt dknngniüguA dre dtrineeesebgAnuilrg nhsee ide hereLr ckshrtii dun egnbe admti hcua Rkncendeülugm sua red Ehfretstcanl rdw.eei ieD hkaecwresGft fedürt cish tmi siemde lreaVehtn olsa keien ernFude mtgaceh ahne.b „hIc knna itchn evoihnczllhean, wmrua se eesid peesurkurz daüirVoungngnk gab. Bei erein egenrnlä rstiF nhätte hcis eid Lteeu fadrua tielnseenl köe“n,nn tniem neaSft elsöL, äcrehrtshGüesff der eslehegresVscklartfh siaPrs-humctilwgudL )VP.(L Es„ tgib hsleadb uahc lvei mntu.U iWr ntaeth emerhre dehurnt Aurfne onv tn,ueeL dei aeusr en.awr erD enoTr aiebd i,ts sdas ise ned tierSk nchso ni ungdrnO ind,efn ebar dei ünigfursdktnnisAg t.hicn“\n\n\
Die rKkiti ecmthö ide ftewahkGscre andgeeg tihcn ufa ihsc nztise ss.nlae „Wir etwllno den rWtikarnse ntigheelci nrägltifgisre iüend.aknng Im Geznggue lnwoelt rwi ebra uach eine rAeghnicsbu ovn dre tiegtierbAerbese, dass ndna ineek eievSrcheetkknattiräritb agetnpl “we,ndre rkretlä rinCsaiht Mnaek ovn rde deiVr srnzedbkLiea ,Nodr ichhbFcaree rrh.Veek tMi eadrenn rnenVbäed esi sda öhmcigl weeesng, mit mde auKelmomnn bnbvdgirreeAaetreb neebkolenogucr-mrmp,MVr red dei Tarivrengndleahunf für eid nleoknamum entUnhemnre ,ürhtf rdnsiaegll nih.ct\n\n\
saD ebah hncti unr ide teser ekWirrdaentunrs tgzei.eg uh„cA iessde laM agb se eengii eietre,Bb dei reihpctierSäeermbnrk gtlsboeau edor nrRenet gpeacnoehsnr ,ebahn bo sei seeDnit rfü hhoe neolgezdhrnSuan üeee“b,rnmnh os iraCihstn Mk,ena rde edn ernutzN sde nfleitnÖehcf vrhenahnnseersPeokr tr,ä chsi älhtcig ba 81 rhU zu nfnee,riorim bo die suBse ma hcnäetsn gaT fhenr.a „Bis zu iserde tihezUr eruvenshc wir ied srkeSit ieükdnnaun.z“g\n\n\
meoeKnmdn ianDgets dteifn ide trtide hrnsnluVdeadruegn erbü edn aiTfr im nfclnieeötfh eieknrbrmhvsOu ni MurnlVrnope-bmreocgkme .atstt eiD Gsrhcwkaetef rdeotfr aidbe ieteiwrhn eien rnghEhöu rde eöhLn nud hreeätlG um 6,02 ourE orp dStenu ab dme 1. aJarnu 2020 ewois suthlczäzi enein ggcegiuanlsrAbehnt nov 010 oE.ru i„De deogeurnFnr isnd mn,aitbitoeri brea eis nsid hacu haslbde so tssfeg,a mu inee Ahucnneiggl an das tebVlegrgsehiice giSsls-ecHetnwlhoi uz csn,efa“fh itemn n-antaHiMrs keBc,ne ontzsVererid esd tbeLteaV.PrsBr-is\n\n\
Die Geünrd für die teSskri tntähe hsci hnac rde teztnle Vanngdhluer thnic gede.nrät aDs gotAben erd btigrAer,bee eastigmsn dnur hecss Penrzot emrh eGdl ni nde emmknonde eird J,arhen ruwde asl ssuaelinzb„tl htcin iha“ceerdsnu gthaeel.nb ldG„e frü enue ekinchT tsi isrkemwwiedeerrüg rmime .ad Jtetz muss rbae ahcu mla ni sechMnen inveeisrtt ,“wnreed gsta iasHnn-tMar e.kBnce irW„ ewni,ss dssa rwi erdean imt eennsru toneAikn teneff,r raeb hwecel nnearde öhtMilngekeic ath ,nma um eisen ugrndrenFoe ez?duehn“crszut\n\n\
iDe ieenkrednSt rktieiirens ecöhtm eSnfta slLöe ,citnh ied ngnredueorF dre wkrehGsceaft tähl er rbea nefbfaro üfr eeirüb.tnrbe „iDe edivr roedtfr im httcSni 51 Ptnroze herm hnSd.ntuoenl sDa rreerbodüft dne “ridskane,L os rde fs.f-üLrreVsPcGähteh ieD elFgo wräe wlh,o sdas adnn inunsegLet, crishp ied hzAlan na aehrtF,n eid utlzezt eaagtsubu uenrd,w chetginers dwrü.ne hIc„ heffo salbhe,d dssa se ma nagteDis ennei hssublscA ,ibgt mti med ide Aeneteltngsl udezirnfe dsin dnu dre ieksnardL hintc ebforüretrd wd“ri.'

let inputTexts = {
  'Original text': originalText,
  'Crypted 1': inputCrypted1,
  'Crypted 2': inputCrypted2,
  'Crypted 3': inputCrypted3,
  'Crypted 4': inputCrypted4,
  'Crypted 5': inputCrypted5
}

// --------------------------------------------------------------------------------------------------------------------------------
let activeText = originalText
let activeGroup = -1
let numLines = 0

// --------------------------------------------------------------------------------------------------------------------------------
function searchGroups () {
  let searchValue = iSearchValue.value.toString()
  if (searchValue.length === 0) return

  let searchSize = searchValue.length
  let searchStartChar = searchValue.charAt(0)
  let searchEndChar = searchValue.charAt(searchSize - 1)

  let adaptedSearchSize = searchSize - 1

  let startIndex = activeText.indexOf(searchStartChar)
  let endIndex = 0

  let isHit = true
  let currentSubIndex = 1
  let subSearchChar = '-'

  let minHitRanges = []
  let maxHitRanges = []

  if (searchSize === 1) {
    // TODO: Handle single or two value search
    while (startIndex !== -1) {
      minHitRanges.push(startIndex)
      maxHitRanges.push(startIndex)
      startIndex = activeText.indexOf(searchStartChar, startIndex + 1)
    }
  } else {
    while (startIndex !== -1) {
      endIndex = activeText.indexOf(searchEndChar, startIndex + 1)
      // TODO: Run until end of file
      if (endIndex === -1) break

      while (endIndex - startIndex < adaptedSearchSize) {
        endIndex = activeText.indexOf(searchEndChar, endIndex + 1)
        if (endIndex === -1) break
      }

      if (endIndex - startIndex === adaptedSearchSize) {
        isHit = true
        currentSubIndex = 1

        let searchString = activeText.substr(startIndex + 1, adaptedSearchSize - 1)
        subSearchChar = searchValue.charAt(currentSubIndex++)
        for (let char of searchString) {
          if (char !== subSearchChar) {
            isHit = false
            break
          } else subSearchChar = searchValue.charAt(currentSubIndex++)
        }

        if (isHit) {
          minHitRanges.push(startIndex)
          maxHitRanges.push(endIndex)
        }
      }

      startIndex = activeText.indexOf(searchStartChar, startIndex + 1)
    }
  }

  if (minHitRanges[0] !== undefined) {
    markRanges(minHitRanges, maxHitRanges)
    document.querySelector('#dataStats #dGroupCount').textContent = minHitRanges.length
    document.querySelector('#dataStats #dGroupFirst').textContent = (minHitRanges[0] + 1) + ' bis ' + (maxHitRanges[0] + 1)
    document.querySelector('#dataStats #dGroupEnd').textContent = (minHitRanges[minHitRanges.length - 1] + 1) + ' bis ' + (maxHitRanges[minHitRanges.length - 1] + 1)

    let percent = ((minHitRanges.length * searchSize) / (1.0 * activeText.length) * 100).toString()
    percent = percent.substr(0, percent.indexOf('.') + 3)

    document.querySelector('#dataStats #dGroupPercent').textContent = percent + ' %'
  }

  fillLineNums(null)
}

// --------------------------------------------------------------------------------------------------------------------------------

function resetGroups () {
  resetActiveGroup()
  let highlightItems = document.querySelectorAll('#dataTab .highlight')

  for (let item of highlightItems) {
    item.removeAttribute('class')
    item.removeEventListener('mouseover', highlightGroup)
    item.removeEventListener('mouseout', unhighlightGroup)
    item.removeEventListener('click', setGroupInfo)
  }

  document.querySelector('#dataStats #dGroupCount').textContent = 0
  document.querySelector('#dataStats #dGroupFirst').textContent = '---'
  document.querySelector('#dataStats #dGroupEnd').textContent = '---'
  document.querySelector('#dataStats #dGroupPercent').textContent = '0 %'

  document.querySelector('#dataMarkerTab #dPiPos').textContent = '0 / ' + (activeText.length + 1)
  document.querySelector('#dataMarkerTab #dPiStart').textContent = '---'
  document.querySelector('#dataMarkerTab #dPiEnd').textContent = '---'
  document.querySelector('#dataMarkerTab #dPiIndex').textContent = '---'

  activeGroup = -1
}

function setSearchValue (event) {
  let searchValue = 0
  let size = 1
  let startIndex = 0
  let endIndex = 0

  if (event === null) {
    let selection = window.getSelection()
    let anchor = selection.anchorNode
    let focus = selection.focusNode

    if (anchor === null || anchor.nodeName !== '#text' || anchor.parentNode === null || anchor.parentNode.dataset['idx'] === undefined || focus.nodeName !== '#text' || focus.parentNode === null || focus.parentNode.dataset['idx'] === undefined) {
      return
    }

    startIndex = parseInt(anchor.parentNode.dataset['idx'])
    endIndex = parseInt(focus.parentNode.dataset['idx'])

    if (startIndex !== endIndex) {
      size = (endIndex < startIndex ? startIndex - endIndex : endIndex - startIndex) + 1
    }

    if (size > 100) {
      window.alert('Die Auswahl kann maximal 100 Zahlen umfassen.')
      return
    }

    searchValue = activeText.substr(startIndex, size)
    iSearchValue.value = searchValue
  } else if (event.target !== null) {
    searchValue = event.target.value
    event.target.value = searchValue

    if (searchValue.length === 0) {
      document.querySelector('#dataMarkerTab #dSearchValue').textContent = '---'
      return
    }

    size = searchValue.length
    startIndex = -2
    endIndex = -2

    if (event.keyCode !== undefined && event.keyCode === 13) {
      document.querySelector('#menu button[data-command="searchGroups"]').click()
    }
  }

  document.querySelector('#dataMarkerTab #dSearchValue').textContent = searchValue
  document.querySelector('#dataMarkerTab #dSearchValueStart').textContent = startIndex + 2
  document.querySelector('#dataMarkerTab #dSearchValueEnd').textContent = endIndex + 2
  document.querySelector('#dataMarkerTab #dSearchValueSize').textContent = size
}

// -----------------------------------------------------------------------------------------------------------------
function bHandleCommands (event) {
  switch (event.target.dataset['command']) {
    case 'searchGroups':
      resetGroups()
      searchGroups()
      // markRanges([0, 5, 10], [3, 8, 12])
      break
    case 'ssearchval':
      setSearchValue(null)
      break
    case 'snext':
      jumpNextGroup()
      break
    case 'sprev':
      jumpPrevGroup()
      break
    case 'sfirst':
      jumpFirstGroup()
      break
    case 'slast':
      jumpLastGroup()
      break
    case 'reset':
      resetApp()
      break
    default:
      break
  }
}

function handleKeyboard (evt) {
  if (evt.target.nodeName !== 'INPUT') {
    switch (evt.keyCode) {
      case 78: // n
        jumpNextGroup()
        break
      case 86: // v
      case 80: // p
        jumpPrevGroup()
        break
      case 69: // e
      case 70: // f
        jumpFirstGroup()
        break
      case 76: // l
        jumpLastGroup()
        break
      default:
        break
    }
  }
}

// -----------------------------------------------------------------------------------------------------------------
function jumpFirstGroup () {
  jumpToGroup(0)
}

// -----------------------------------------------------------------------------------------------------------------
function jumpLastGroup () {
  let groupCount = document.querySelectorAll('#dataTab .highlight.first').length - 1
  if (groupCount < 0) return
  jumpToGroup(groupCount)
}

// -----------------------------------------------------------------------------------------------------------------
function jumpToGroup (group) {
  let firstElement = document.querySelector('#dataTab .highlight.first[data-grp="' + group + '"]')
  if (firstElement === null) return

  activeGroup = group
  firstElement.click()

  dataTab.scrollTop = firstElement.offsetTop - (dataTab.clientHeight * 0.75)
}

// -----------------------------------------------------------------------------------------------------------------
function jumpNextGroup () {
  let groupCount = document.querySelectorAll('#dataTab .highlight.first').length - 1
  if (groupCount < 0) return

  if (activeGroup === -1 || activeGroup === groupCount) jumpToGroup(0)
  else jumpToGroup(++activeGroup)
}

// -----------------------------------------------------------------------------------------------------------------
function jumpPrevGroup () {
  let groupCount = document.querySelectorAll('#dataTab .highlight.first').length - 1
  if (groupCount < 0) return

  if (activeGroup <= 0) jumpToGroup(groupCount)
  else jumpToGroup(--activeGroup)
}

// -----------------------------------------------------------------------------------------------------------------

function markRanges (minTargets, maxTargets) {
  if (minTargets.length !== maxTargets.length) return

  let dataTabChildren = dataTab.children

  let currentGroup = 0
  for (let index in minTargets) {
    let startIndex = minTargets[index]
    let endIndex = maxTargets[index]

    if (startIndex === endIndex) {
      let child = dataTabChildren[startIndex]
      child.dataset['grp'] = currentGroup
      child.classList.add('highlight')
      child.classList.add('first')
      child.classList.add('last')
      child.addEventListener('mouseover', highlightGroup)
      child.addEventListener('mouseout', unhighlightGroup)
      child.addEventListener('click', setGroupInfo)
    } else {
      for (let current = startIndex; current <= endIndex; ++current) {
        let child = dataTabChildren[current]
        child.dataset['grp'] = currentGroup

        if (current === startIndex) {
          child.classList.add('highlight')
          child.classList.add('first')
        } else if (current < endIndex) {
          child.classList.add('highlight')
        } else {
          child.classList.add('highlight')
          child.classList.add('last')
        }

        child.addEventListener('mouseover', highlightGroup)
        child.addEventListener('mouseout', unhighlightGroup)
        child.addEventListener('click', setGroupInfo)
      }
    }

    ++currentGroup
  }
}

function highlightGroup (event) {
  if (event.target.classList.contains('mouseover')) return

  let groupMembers = document.querySelectorAll('#dataTab .highlight[data-grp="' + event.target.dataset['grp'] + '"]')
  for (let elm of groupMembers) {
    elm.classList.add('mouseover')
  }
}

function unhighlightGroup (event) {
  let groupMembers = document.querySelectorAll('#dataTab .highlight[data-grp="' + event.target.dataset['grp'] + '"]')

  for (let elm of groupMembers) {
    elm.classList.remove('mouseover')
  }
}

// -----------------------------------------------------------------------------------------------------------------

let controls = document.querySelectorAll('button')
for (let control of controls) {
  if (control.dataset['command'] !== undefined) {
    control.addEventListener('click', bHandleCommands)
  }
}

function resetActiveGroup () {
  let firstElement = document.querySelector('#dataTab .highlight.first.active')
  if (firstElement === null) return

  let lastElement = document.querySelector('#dataTab .highlight.last.active')

  for (let i = parseInt(firstElement.dataset['idx']), j = parseInt(lastElement.dataset['idx']) + 1; i < j; ++i) {
    dataTab.children[i].classList.remove('active')
  }
}

function setGroupInfo (event) {
  resetActiveGroup()

  let group = parseInt(event.target.dataset['grp'])
  activeGroup = group

  let firstElement = document.querySelector('#dataTab .highlight.first[data-grp="' + group + '"]')
  if (firstElement === null) return

  let lastElement = document.querySelector('#dataTab .highlight.last[data-grp="' + group + '"]')

  for (let i = parseInt(firstElement.dataset['idx']), j = parseInt(lastElement.dataset['idx']) + 1; i < j; ++i) {
    dataTab.children[i].classList.add('active')
  }

  document.querySelector('#dataMarkerTab #dPiPos').textContent = (parseInt(firstElement.dataset['idx']) + 1) + ' / ' + (activeText.length + 1)
  document.querySelector('#dataMarkerTab #dPiStart').textContent = parseInt(firstElement.dataset['idx']) + 1
  document.querySelector('#dataMarkerTab #dPiEnd').textContent = parseInt(lastElement.dataset['idx']) + 1
  document.querySelector('#dataMarkerTab #dPiIndex').textContent = parseInt(group) + 1
}

function resetApp () {
  resetGroups()

  iSearchValue.value = ''

  document.querySelector('#dataMarkerTab #dSearchValue').textContent = '---'
  document.querySelector('#dataMarkerTab #dSearchValueStart').textContent = 0
  document.querySelector('#dataMarkerTab #dSearchValueEnd').textContent = 0
  document.querySelector('#dataMarkerTab #dSearchValueSize').textContent = 0
}

// -----------------------------------------------------------------------------------------------------------------

function scrollLineNums (event) {
  dataLineTab.scrollTop = dataTab.scrollTop
  let firstActiveLine = Math.floor(dataTab.scrollTop / dataTab.children[0].offsetHeight)
  let lastActiveLine = Math.floor((dataTab.scrollTop + dataTab.clientHeight - 28) / dataTab.children[0].offsetHeight)

  if (lastActiveLine >= dataLineTab.children.length) lastActiveLine = dataLineTab.children.length - 1

  let currentActiveLine = document.querySelectorAll('#dataLineTab .active')
  for (let line of currentActiveLine) {
    line.classList.remove('active')
  }

  dataLineTab.children[Math.floor((firstActiveLine + lastActiveLine - 1) * 0.5)].classList.add('active')
  dataLineTab.children[firstActiveLine].classList.add('active')
  dataLineTab.children[lastActiveLine].classList.add('active')
}

// -----------------------------------------------------------------------------------------------------------------

function fillDataTab () {
  let htmlDataPool = []

  for (let index in activeText) {
    let spanElement = document.createElement('span')
    spanElement.dataset['idx'] = index
    spanElement.dataset['v'] = activeText[index]
    spanElement.textContent = activeText[index]
    htmlDataPool.push(spanElement.outerHTML)
  }

  dataTab.innerHTML = htmlDataPool.join('').replace(/\n/g, '<br>')
}

// -----------------------------------------------------------------------------------------------------------------

function fillLineNums (event) {
  let countedLines = Math.floor(1.0 * dataTab.scrollHeight / dataTab.children[0].offsetHeight) - 1

  if (event !== null && numLines === countedLines) return

  let htmlDataPool = []
  let lineNumber = 1

  let lineElement = null
  let offsetLeft = 0
  for (let element of dataTab.children) {
    offsetLeft = element.offsetLeft
    if (offsetLeft === 84 && element.dataset['v'] === '<br>') {
      ++lineNumber
      continue
    } else if (offsetLeft === 84 && element.dataset['v'] !== '<br>') {
      lineElement = document.createElement('span')
      lineElement.textContent = lineNumber
    } else if (offsetLeft > 84 && element.dataset['v'] === '<br>') {
      lineElement = document.createElement('span')
      lineElement.textContent = ++lineNumber
    } else continue

    htmlDataPool.push(lineElement.outerHTML)
  }

  dataLineTab.innerHTML = htmlDataPool.join('')
  numLines = lineNumber

  let highlightedLines = document.querySelectorAll('#dataTab .lineHighlight')
  for (let line of highlightedLines) line.classList.remove('lineHighlight')

  scrollLineNums(null)
}

// -----------------------------------------------------------------------------------------------------------------
let dataTab = document.querySelector('#dataTab')
dataTab.style['height'] = document.querySelector('#dataMarkerTab').clientHeight + 'px'
dataTab.addEventListener('scroll', scrollLineNums)

let dataLineTab = document.querySelector('#dataLineTab')
dataLineTab.style['height'] = dataTab.clientHeight + 'px'

document.querySelector('#dataMarkerTab #dPiPos').textContent = '0 / ' + (activeText.length + 1)

let iSearchValue = document.querySelector('#menu #iSearchValue')
iSearchValue.addEventListener('change', setSearchValue)
iSearchValue.addEventListener('keyup', setSearchValue)

document.addEventListener('keydown', handleKeyboard)
window.addEventListener('resize', fillLineNums)

let textSelectionArea = document.querySelector('#targetTexts')
for (let inputKey of Object.keys(inputTexts)) {
  let button = document.createElement('button')
  button.appendChild(document.createTextNode(inputKey))
  button.dataset['src'] = inputKey
  button.className = 'textButton'

  button.addEventListener('click', function (evt) {
    activeText = inputTexts[evt.target.dataset['src']]

    resetGroups()
    document.querySelector('#dataMarkerTab #dSearchValue').textContent = '---'
    document.querySelector('#dataMarkerTab #dSearchValueStart').textContent = 0
    document.querySelector('#dataMarkerTab #dSearchValueEnd').textContent = 0
    document.querySelector('#dataMarkerTab #dSearchValueSize').textContent = 0

    fillDataTab()
    fillLineNums()
  })

  textSelectionArea.appendChild(button)
}

fillDataTab()
fillLineNums()

// -----------------------------------------------------------------------------------------------------------------
